/**
 * Copyright (c) 2000-2013 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package it.tref.liferay.mapit.map.model;

import com.liferay.portal.kernel.util.Validator;
import com.liferay.portal.model.ModelWrapper;

import java.util.HashMap;
import java.util.Map;

/**
 * <p>
 * This class is a wrapper for {@link PluginPortletPreferences}.
 * </p>
 *
 * @author
 * @see PluginPortletPreferences
 * @generated
 */
public class PluginPortletPreferencesWrapper implements PluginPortletPreferences,
	ModelWrapper<PluginPortletPreferences> {
	public PluginPortletPreferencesWrapper(
		PluginPortletPreferences pluginPortletPreferences) {
		_pluginPortletPreferences = pluginPortletPreferences;
	}

	@Override
	public Class<?> getModelClass() {
		return PluginPortletPreferences.class;
	}

	@Override
	public String getModelClassName() {
		return PluginPortletPreferences.class.getName();
	}

	@Override
	public Map<String, Object> getModelAttributes() {
		Map<String, Object> attributes = new HashMap<String, Object>();

		attributes.put("pluginPortletPreferencesId",
			getPluginPortletPreferencesId());
		attributes.put("ownerId", getOwnerId());
		attributes.put("ownerType", getOwnerType());
		attributes.put("plid", getPlid());
		attributes.put("portletId", getPortletId());
		attributes.put("plugin", getPlugin());
		attributes.put("preferences", getPreferences());

		return attributes;
	}

	@Override
	public void setModelAttributes(Map<String, Object> attributes) {
		Long pluginPortletPreferencesId = (Long)attributes.get(
				"pluginPortletPreferencesId");

		if (pluginPortletPreferencesId != null) {
			setPluginPortletPreferencesId(pluginPortletPreferencesId);
		}

		Long ownerId = (Long)attributes.get("ownerId");

		if (ownerId != null) {
			setOwnerId(ownerId);
		}

		Integer ownerType = (Integer)attributes.get("ownerType");

		if (ownerType != null) {
			setOwnerType(ownerType);
		}

		Long plid = (Long)attributes.get("plid");

		if (plid != null) {
			setPlid(plid);
		}

		String portletId = (String)attributes.get("portletId");

		if (portletId != null) {
			setPortletId(portletId);
		}

		String plugin = (String)attributes.get("plugin");

		if (plugin != null) {
			setPlugin(plugin);
		}

		String preferences = (String)attributes.get("preferences");

		if (preferences != null) {
			setPreferences(preferences);
		}
	}

	/**
	* Returns the primary key of this plugin portlet preferences.
	*
	* @return the primary key of this plugin portlet preferences
	*/
	@Override
	public long getPrimaryKey() {
		return _pluginPortletPreferences.getPrimaryKey();
	}

	/**
	* Sets the primary key of this plugin portlet preferences.
	*
	* @param primaryKey the primary key of this plugin portlet preferences
	*/
	@Override
	public void setPrimaryKey(long primaryKey) {
		_pluginPortletPreferences.setPrimaryKey(primaryKey);
	}

	/**
	* Returns the plugin portlet preferences ID of this plugin portlet preferences.
	*
	* @return the plugin portlet preferences ID of this plugin portlet preferences
	*/
	@Override
	public long getPluginPortletPreferencesId() {
		return _pluginPortletPreferences.getPluginPortletPreferencesId();
	}

	/**
	* Sets the plugin portlet preferences ID of this plugin portlet preferences.
	*
	* @param pluginPortletPreferencesId the plugin portlet preferences ID of this plugin portlet preferences
	*/
	@Override
	public void setPluginPortletPreferencesId(long pluginPortletPreferencesId) {
		_pluginPortletPreferences.setPluginPortletPreferencesId(pluginPortletPreferencesId);
	}

	/**
	* Returns the owner ID of this plugin portlet preferences.
	*
	* @return the owner ID of this plugin portlet preferences
	*/
	@Override
	public long getOwnerId() {
		return _pluginPortletPreferences.getOwnerId();
	}

	/**
	* Sets the owner ID of this plugin portlet preferences.
	*
	* @param ownerId the owner ID of this plugin portlet preferences
	*/
	@Override
	public void setOwnerId(long ownerId) {
		_pluginPortletPreferences.setOwnerId(ownerId);
	}

	/**
	* Returns the owner type of this plugin portlet preferences.
	*
	* @return the owner type of this plugin portlet preferences
	*/
	@Override
	public int getOwnerType() {
		return _pluginPortletPreferences.getOwnerType();
	}

	/**
	* Sets the owner type of this plugin portlet preferences.
	*
	* @param ownerType the owner type of this plugin portlet preferences
	*/
	@Override
	public void setOwnerType(int ownerType) {
		_pluginPortletPreferences.setOwnerType(ownerType);
	}

	/**
	* Returns the plid of this plugin portlet preferences.
	*
	* @return the plid of this plugin portlet preferences
	*/
	@Override
	public long getPlid() {
		return _pluginPortletPreferences.getPlid();
	}

	/**
	* Sets the plid of this plugin portlet preferences.
	*
	* @param plid the plid of this plugin portlet preferences
	*/
	@Override
	public void setPlid(long plid) {
		_pluginPortletPreferences.setPlid(plid);
	}

	/**
	* Returns the portlet ID of this plugin portlet preferences.
	*
	* @return the portlet ID of this plugin portlet preferences
	*/
	@Override
	public java.lang.String getPortletId() {
		return _pluginPortletPreferences.getPortletId();
	}

	/**
	* Sets the portlet ID of this plugin portlet preferences.
	*
	* @param portletId the portlet ID of this plugin portlet preferences
	*/
	@Override
	public void setPortletId(java.lang.String portletId) {
		_pluginPortletPreferences.setPortletId(portletId);
	}

	/**
	* Returns the plugin of this plugin portlet preferences.
	*
	* @return the plugin of this plugin portlet preferences
	*/
	@Override
	public java.lang.String getPlugin() {
		return _pluginPortletPreferences.getPlugin();
	}

	/**
	* Sets the plugin of this plugin portlet preferences.
	*
	* @param plugin the plugin of this plugin portlet preferences
	*/
	@Override
	public void setPlugin(java.lang.String plugin) {
		_pluginPortletPreferences.setPlugin(plugin);
	}

	/**
	* Returns the preferences of this plugin portlet preferences.
	*
	* @return the preferences of this plugin portlet preferences
	*/
	@Override
	public java.lang.String getPreferences() {
		return _pluginPortletPreferences.getPreferences();
	}

	/**
	* Sets the preferences of this plugin portlet preferences.
	*
	* @param preferences the preferences of this plugin portlet preferences
	*/
	@Override
	public void setPreferences(java.lang.String preferences) {
		_pluginPortletPreferences.setPreferences(preferences);
	}

	@Override
	public boolean isNew() {
		return _pluginPortletPreferences.isNew();
	}

	@Override
	public void setNew(boolean n) {
		_pluginPortletPreferences.setNew(n);
	}

	@Override
	public boolean isCachedModel() {
		return _pluginPortletPreferences.isCachedModel();
	}

	@Override
	public void setCachedModel(boolean cachedModel) {
		_pluginPortletPreferences.setCachedModel(cachedModel);
	}

	@Override
	public boolean isEscapedModel() {
		return _pluginPortletPreferences.isEscapedModel();
	}

	@Override
	public java.io.Serializable getPrimaryKeyObj() {
		return _pluginPortletPreferences.getPrimaryKeyObj();
	}

	@Override
	public void setPrimaryKeyObj(java.io.Serializable primaryKeyObj) {
		_pluginPortletPreferences.setPrimaryKeyObj(primaryKeyObj);
	}

	@Override
	public com.liferay.portlet.expando.model.ExpandoBridge getExpandoBridge() {
		return _pluginPortletPreferences.getExpandoBridge();
	}

	@Override
	public void setExpandoBridgeAttributes(
		com.liferay.portal.model.BaseModel<?> baseModel) {
		_pluginPortletPreferences.setExpandoBridgeAttributes(baseModel);
	}

	@Override
	public void setExpandoBridgeAttributes(
		com.liferay.portlet.expando.model.ExpandoBridge expandoBridge) {
		_pluginPortletPreferences.setExpandoBridgeAttributes(expandoBridge);
	}

	@Override
	public void setExpandoBridgeAttributes(
		com.liferay.portal.service.ServiceContext serviceContext) {
		_pluginPortletPreferences.setExpandoBridgeAttributes(serviceContext);
	}

	@Override
	public java.lang.Object clone() {
		return new PluginPortletPreferencesWrapper((PluginPortletPreferences)_pluginPortletPreferences.clone());
	}

	@Override
	public int compareTo(
		it.tref.liferay.mapit.map.model.PluginPortletPreferences pluginPortletPreferences) {
		return _pluginPortletPreferences.compareTo(pluginPortletPreferences);
	}

	@Override
	public int hashCode() {
		return _pluginPortletPreferences.hashCode();
	}

	@Override
	public com.liferay.portal.model.CacheModel<it.tref.liferay.mapit.map.model.PluginPortletPreferences> toCacheModel() {
		return _pluginPortletPreferences.toCacheModel();
	}

	@Override
	public it.tref.liferay.mapit.map.model.PluginPortletPreferences toEscapedModel() {
		return new PluginPortletPreferencesWrapper(_pluginPortletPreferences.toEscapedModel());
	}

	@Override
	public it.tref.liferay.mapit.map.model.PluginPortletPreferences toUnescapedModel() {
		return new PluginPortletPreferencesWrapper(_pluginPortletPreferences.toUnescapedModel());
	}

	@Override
	public java.lang.String toString() {
		return _pluginPortletPreferences.toString();
	}

	@Override
	public java.lang.String toXmlString() {
		return _pluginPortletPreferences.toXmlString();
	}

	@Override
	public void persist()
		throws com.liferay.portal.kernel.exception.SystemException {
		_pluginPortletPreferences.persist();
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}

		if (!(obj instanceof PluginPortletPreferencesWrapper)) {
			return false;
		}

		PluginPortletPreferencesWrapper pluginPortletPreferencesWrapper = (PluginPortletPreferencesWrapper)obj;

		if (Validator.equals(_pluginPortletPreferences,
					pluginPortletPreferencesWrapper._pluginPortletPreferences)) {
			return true;
		}

		return false;
	}

	/**
	 * @deprecated As of 6.1.0, replaced by {@link #getWrappedModel}
	 */
	public PluginPortletPreferences getWrappedPluginPortletPreferences() {
		return _pluginPortletPreferences;
	}

	@Override
	public PluginPortletPreferences getWrappedModel() {
		return _pluginPortletPreferences;
	}

	@Override
	public void resetOriginalValues() {
		_pluginPortletPreferences.resetOriginalValues();
	}

	private PluginPortletPreferences _pluginPortletPreferences;
}