package it.tref.liferay.mapit.map.util;

import java.lang.reflect.InvocationHandler;
import java.lang.reflect.Method;

import com.liferay.portal.kernel.util.ReflectionUtil;

public class MapItPluginInvocationHandler implements InvocationHandler {

  private Object object;

  public MapItPluginInvocationHandler(Object object) {
    this.object = object;
  }

  @Override
  public Object invoke(Object proxy, Method method, Object[] args) throws Throwable {

    if (method.getDeclaringClass() == Object.class) {
      String methodName = method.getName();

      if (methodName.equals("equals")) {
        if (proxy == args[0]) {
          return true;
        } else {
          return false;
        }
      }
    }

    Class<?> clazz = object.getClass();
    ClassLoader classLoader = clazz.getClassLoader();

    Thread currentThread = Thread.currentThread();

    ClassLoader contextClassLoader = currentThread.getContextClassLoader();

    try {

      if (classLoader != contextClassLoader) {
        currentThread.setContextClassLoader(classLoader);
      }

      return ReflectionUtil.getDeclaredMethod(clazz, method.getName(), method.getParameterTypes()).invoke(object, args);
    } finally {
      currentThread.setContextClassLoader(contextClassLoader);
    }
  }

}
